/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// AR_MAP.C

#include "CK_DEF.H"
#pragma	hdrstop

/*
=============================================================================

LOCAL CONSTANTS

=============================================================================
*/


/*
=============================================================================

GLOBAL VARIABLES

=============================================================================
*/

CK_action CK_ACT_MapKeenStart = { 0x0, 0x0, AT_UnscaledFrame, 0x0, 0x0, 0x168, 0x0, 0x0, CK_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWave0};
CK_action CK_ACT_MapKeenWave0 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWave1};
CK_action CK_ACT_MapKeenWave1 = { WORLDKEENWAVE2SPR, WORLDKEENWAVE2SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWave2};
CK_action CK_ACT_MapKeenWave2 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWave3};
CK_action CK_ACT_MapKeenWave3 = { WORLDKEENWAVE2SPR, WORLDKEENWAVE2SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWave4};
CK_action CK_ACT_MapKeenWave4 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK_MapKeenWalk, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenStart};
CK_action CK_ACT_MapKeenWalk0 = { 0x0, 0x0, AT_ScaledOnce, 0x1, 0x0, 0x4, 0x18, 0x18, CK_MapKeenWalk, NULL, CK_BasicDrawFunc1, &CK_ACT_MapKeenWalk0};

//===========================================================================
//
// MAP KEEN
//
//===========================================================================


static int ck_mapKeenFrames[] ={ WORLDKEENU1SPR-1, WORLDKEENUR1SPR-1, WORLDKEENR1SPR-1, WORLDKEENDR1SPR-1, WORLDKEEND1SPR-1, WORLDKEENDL1SPR-1, WORLDKEENL1SPR-1, WORLDKEENUL1SPR-1 };
static int word_417BA[] ={ 2, 3, 1, 3}; 

void CK_SpawnMapKeen(int tileX, int tileY)
{

	ck_keenObj->type = 2;
	if (ck_gameState.mapPosX == 0)
	{
		ck_keenObj->posX = (tileX << 8);
		ck_keenObj->posY = (tileY << 8);
	}
	else
	{
		ck_keenObj->posX = ck_gameState.mapPosX;
		ck_keenObj->posY = ck_gameState.mapPosY;
	}

	ck_keenObj->active = OBJ_ALWAYS_ACTIVE;
	ck_keenObj->zLayer = 1;
	ck_keenObj->xDirection= ck_keenObj->yDirection = motion_None;
	ck_keenObj->user1 = 6;
	ck_keenObj->user2 = 3;
	ck_keenObj->user3 = 0;
	ck_keenObj->gfxChunk = WORLDKEENDR1SPR;
	CK_SetAction(ck_keenObj, &CK_ACT_MapKeenStart);
}



//look for level entrry

void CK_ScanForLevelEntry(CK_object * obj)
{

	int tx, ty;

	for (ty = obj->clipRects.tileY1; ty <= obj->clipRects.tileY2; ty++)
	{
		for (tx = obj->clipRects.tileX1; tx <= obj->clipRects.tileX2; tx++)
		{
			unsigned infotile = CA_TileAtPos(tx, ty, 2);
			if (infotile > 0xC000 && infotile <= 0xC001)
			{
				// Vanilla keen stores the current map loaded in the cache manager
				// and the "current_map" variable stored in the gamestate
				// would have been changed here.
				ck_gameState.mapPosX = obj->posX;
				ck_gameState.mapPosY = obj->posY;
				ck_gameState.currentLevel = infotile - 0xC000;
				ck_levelState = 2;
				SD_PlaySound(UNKNOWN12SND);
				return;
			}
		}
	}
}

void CK_MapKeenStill(CK_object * obj)
{

	if (ck_inputFrame.dir != dir_None)
	{
		obj->currentAction = &CK_ACT_MapKeenWalk0;
		obj->user2 = 0;
		CK_MapKeenWalk(obj);
	}

	if (ck_keenState.jumpIsPressed || ck_keenState.pogoIsPressed || ck_keenState.shootIsPressed)
	{
		CK_ScanForLevelEntry(obj);
	}
}

// user1 = last dir;
// user2 = walking frame ticker
// user3 = 
void CK_MapKeenWalk(CK_object * obj)
{

	if (obj->user3 == 0)
	{
		obj->xDirection = ck_inputFrame.xaxis;
		obj->yDirection = ck_inputFrame.yaxis;
		if (ck_keenState.pogoIsPressed || ck_keenState.jumpIsPressed || ck_keenState.shootIsPressed)
			CK_ScanForLevelEntry(obj);

		// Go back to standing if no arrows pressed
		if (ck_inputFrame.dir == dir_None)
		{
			obj->currentAction = &CK_ACT_MapKeenStart;
			obj->gfxChunk = ck_mapKeenFrames[obj->user1] + 3;
			return;
		}
		else
		{
			obj->user1 = ck_inputFrame.dir;
		}
	}
	else
	{
		if ((obj->user3 -= 4) < 0)
			obj->user3 = 0;
	}

	// Advance Walking Frame Animation
	if (++obj->user2 == 4)
		obj->user2 = 0;
	obj->gfxChunk = ck_mapKeenFrames[obj->user1] + word_417BA[obj->user2];

	//walk hi lo sound
	if (obj->user2 == 1)
	{
		SD_PlaySound(KEENWALK0SND);
	}
	else if (obj->user2 == 3)
	{
		SD_PlaySound(KEENWALK1SND);
	}
}



void CK_MapMiscFlagsCheck(CK_object *keen)
{

	int midTileX, midTileY;
	unsigned tile;
	byte info;

	if (keen->user3)
		return;

	midTileX = keen->clipRects.tileXmid;
	midTileY = ((keen->clipRects.unitY2 - keen->clipRects.unitY1) / 2 + keen->clipRects.unitY1) >> 8;

	tile = *((unsigned _seg *)mapsegs[1] + mapbwidthtable[midTileY]/2 + midTileX);
	info = tinf[INTILE+tile];

	switch (info)
	{
		// Check for special tile properties here
		default:
			break;
	}

}

//===========================================================================
//
// MAP FLAGS
// 
//===========================================================================

CK_action CK_ACT_MapFlagFlips0 ;
CK_action CK_ACT_MapFlagFlips1 ;
CK_action CK_ACT_MapFlagFlips2 ;
CK_action CK_ACT_MapFlagFlips3 ;
CK_action CK_ACT_MapFlagFlips4 ;
CK_action CK_ACT_MapFlagFlips5 ;
CK_action CK_ACT_MapFlagFlips6 ;


CK_action CK_ACT_MapFlag0 ;
CK_action CK_ACT_MapFlag1 ;
CK_action CK_ACT_MapFlag2 ;
CK_action CK_ACT_MapFlag3 ;

void CK_MapFlagSpawn(unsigned tileX, unsigned tileY);
void CK_SpawnFlippingFlag(unsigned tileX, unsigned tileY);
void CK_KeenFlagThrown (CK_object *obj);
void CK_KeenFlagSearch (CK_object *obj);
void CK_KeenFlagLands(CK_object *obj);


CK_action CK_ACT_MapFlagFlips0 = { FLAGFLIP1SPR, FLAGFLIP1SPR, AT_Frame, 0, 0, 6, 0, 0, CK_KeenFlagThrown, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips1};
CK_action CK_ACT_MapFlagFlips1 = { FLAGFLIP1SPR, FLAGFLIP1SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips2};
CK_action CK_ACT_MapFlagFlips2 = { FLAGFLIP2SPR, FLAGFLIP2SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips3};
CK_action CK_ACT_MapFlagFlips3 = { FLAGFLIP3SPR, FLAGFLIP3SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips4};
CK_action CK_ACT_MapFlagFlips4 = { FLAGFLIP4SPR, FLAGFLIP4SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips5};
CK_action CK_ACT_MapFlagFlips5 = { FLAGFLIP4SPR, FLAGFLIP4SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlagFlips6};
CK_action CK_ACT_MapFlagFlips6 = { FLAGFLIP6SPR, FLAGFLIP6SPR, AT_UnscaledFrame, true, 0, 1, 0, 0, CK_KeenFlagLands, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlag0};


CK_action CK_ACT_MapFlag0 = { FLAGWAVE1SPR, FLAGWAVE1SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlag1};
CK_action CK_ACT_MapFlag1 = { FLAGWAVE2SPR, FLAGWAVE2SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlag2};
CK_action CK_ACT_MapFlag2 = { FLAGWAVE3SPR, FLAGWAVE3SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlag3};
CK_action CK_ACT_MapFlag3 = { FLAGWAVE4SPR, FLAGWAVE4SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_MapFlag0};

void CK_MapFlagSpawn(unsigned tileX, unsigned tileY)
{

	CK_object *flag = CK_GetNewObj(false);

	flag->clipped = CLIP_not;
	flag->zLayer = PRIORITIES-2;
	flag->type = CT_MapFlag;
	flag->active = OBJ_ACTIVE;
	flag->posX = (tileX << 8) + 0x60;
	flag->posY = (tileY << 8) - 0x1E0;
	flag->actionTimer = US_RndT() / 16;
	CK_SetAction(flag, &CK_ACT_MapFlag0);
}

typedef struct {
	unsigned x, y;
} flagpointtype;

flagpointtype flagpoints[30];

void CK_SpawnFlippingFlag(unsigned tileX, unsigned tileY)
{

	CK_object *newobj;
	long deltaX, deltaY;
	int i;

	newobj = CK_GetNewObj(false);
	newobj->clipped = CLIP_not;
	newobj->zLayer = PRIORITIES - 2;
	newobj->type = CT_MapFlag;
	newobj->active = OBJ_ALWAYS_ACTIVE;
	newobj->posX = ck_gameState.mapPosX - 0x100;
	newobj->posY = ck_gameState.mapPosY - 0x100;

	// Destination coordinates
	newobj->user1 = (tileX<<8) + 0x60;
	newobj->user2 = (tileY<<8) - 0x260;
	
	deltaX = (int)newobj->user1 - (int)newobj->posX;
	deltaY = (int)newobj->user2 - (int)newobj->posY;

	// Make a table of coordinates for the flag's path
	for (i = 0; i < 30; i++)
	{

		// Draw points in a straight line between keen and the holster
		flagpoints[i].x = newobj->posX + deltaX*(i<24?i:24)/24;
		flagpoints[i].y = newobj->posY + deltaY*i/30;

		// Offset the Y points to mimic a parabolic trajectory
		if (i < 10)
			flagpoints[i].y -= i * 0x30;
		else if (i < 15) // starts to level
			flagpoints[i].y -= i * 16 + 0x140;
		else if (i < 20) // flag starts falling
			flagpoints[i].y -= (20 - i) * 16 + 0x1E0;
		else 		// starts falling faster
			flagpoints[i].y -= (29 - i) * 0x30;
	}

	CK_SetAction(newobj, &CK_ACT_MapFlagFlips0);
}



void CK_KeenFlagThrown (CK_object *obj)
{
	// Start the throw when screen becomes light
	if (!screenfaded)
	{
		SD_StopSound();
		SD_PlaySound(0x2B);
		obj->currentAction = obj->currentAction->next;
	}
}


void CK_KeenFlagSearch (CK_object *obj)
{
	obj->user3 += tics;

	if (obj->user3 > 58)
		obj->user3 = 58;

	// Move the flag along the path
	obj->posX = flagpoints[obj->user3/2].x;
	obj->posY = flagpoints[obj->user3/2].y;

	obj->visible = true;
	if (!obj->user1)
		SD_PlaySound(0x2B);
}

void CK_KeenFlagLands(CK_object *obj)
{

	// Put the flag in its holster
	obj->posX = obj->user1;
	obj->posY = obj->user2 + 0x80;

	SD_PlaySound(0x2C);
}

