/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// AR_MISC.C

#include "CK_DEF.H"
#pragma	hdrstop

/*
=============================================================================

LOCAL CONSTANTS

=============================================================================
*/




/*
=============================================================================

GLOBAL VARIABLES

=============================================================================
*/

const char *ck_levelNames[] = {

	"The World Map",
	"The Only Level",
	"The High Scores",
};

// HACK: Sorry, the strings need to be in WRITABLE storage,
// because US_CPrint (temporarily) modifies them.


char ck_levelEntryText_0[] =
	"Keen searches\n the World Map";

char ck_levelEntryText_1[] =
	"Keen explores the \n Only Level";

char ck_levelEntryText_2[] =
	"Keen tallies\n the High Scores";


char *ck_levelEntryTexts[] = {
	ck_levelEntryText_0,
	ck_levelEntryText_1,
	ck_levelEntryText_2,
};
/*
=============================================================================

LOCAL VARIABLES

=============================================================================
*/

void CK_ObjBadState (void);

CK_action CK_ACT_Null = {0, 0, AT_Frame, false, false, 0, 0, 0, (void (*)(CK_object *))CK_ObjBadState, (void (*)(CK_object *, CK_object *))CK_ObjBadState, (void (*)(CK_object *))CK_ObjBadState, NULL};



//===========================================================================

// Contains some keen-5 specific functions.






#define KEENLUMP 0
#define MAPKEENLUMP 1
#define PLATFORMLUMP 2

#define NUMLUMPS 40

int ck_lumpsNeeded[NUMLUMPS];

int ck_lumpStarts[] = {
	KEEN_LUMP_START,
	WORLDKEEN_LUMP_START,
	PLATFORM_LUMP_START,

};

int ck_lumpEnds[] = {
	KEEN_LUMP_END,
	WORLDKEEN_LUMP_END,
	PLATFORM_LUMP_END,
};

void CK_ScanInfoLayer(void)
{

	CK_object *obj;
	int x, y, infoValue, i,j;
	int mapW = mapwidth;
	int mapH = mapheight;

	memset(ck_lumpsNeeded, 0, sizeof(ck_lumpsNeeded));

	for (y = 0; y < mapH; ++y)
	{
		for (x = 0; x < mapW; ++x)
		{
			infoValue = *(mapsegs[2]+y * mapW + x);
			switch (infoValue)
			{
			case 1:
				CK_SpawnKeen(x, y, 1);
				ck_lumpsNeeded[KEENLUMP] = true;
				SpawnScore();
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				break;
			case 2:
				CK_SpawnKeen(x, y, -1);
				ck_lumpsNeeded[KEENLUMP] = true;
				SpawnScore();
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				break;

			case 3:

				CK_SpawnMapKeen(x, y);
				ck_lumpsNeeded[MAPKEENLUMP] = true;

				SpawnScore();
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				break;

		


			case 25:
				RF_SetScrollBlock(x,y,true);
				break;
			case 26:
				RF_SetScrollBlock(x,y,false);
				break;

			case 27:
			case 28:
			case 29:
			case 30:
				CK_SpawnAxisPlatform(x,y,infoValue-27);
				ck_lumpsNeeded[PLATFORMLUMP] = true;
				break;


			case 32:
				CK_SpawnFallPlat(x,y);
				ck_lumpsNeeded[PLATFORMLUMP] = true;
				break;


			// Items
			case 57:
			case 58:
			case 59:
			case 60:
			case 61:
			case 62:
			case 63:
			case 64:
			case 65:
			case 66:
			case 67:
			case 68:
				CK_SpawnItem(x,y,infoValue-57);	
				break;

			}
		}
	}

	// Inactivate all objects
	for (obj = ck_keenObj; obj != NULL; obj = obj->next)
	{
		if (obj->active != OBJ_ALWAYS_ACTIVE)
			obj->active = OBJ_INACTIVE;
	}

	// Cache chunks
	for (i = 0; i < NUMLUMPS; i++)
	{
		if (!ck_lumpsNeeded[i])
			continue;

		for (j = ck_lumpStarts[i]; j <= ck_lumpEnds[i]; j++)
		{
			grneeded[j] |= ca_levelbit;
		}
	}
	
}
