/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// KD_PLAY.C

#include "CK_DEF.H"
#pragma	hdrstop

/*
=============================================================================

   LOCAL CONSTANTS

=============================================================================
   */

#define	INACTIVATEDIST	10

#define CK_MAX_OBJECTS 100
/*
=============================================================================

   GLOBAL VARIABLES

=============================================================================
   */


boolean		button0held,button1held;

unsigned	originxtilemax,originytilemax;

ControlInfo	ck_inputFrame;


CK_object ck_objArray[CK_MAX_OBJECTS];

CK_object *ck_freeObject;
CK_object *ck_lastObject;
int ck_numObjects;

CK_object *ck_keenObj;
CK_object *ck_scoreBoxObj;

static CK_object tempObj;

// The rectangle within which objects are active.
int ck_activeX0Tile;
int ck_activeY0Tile;
int ck_activeX1Tile;
int ck_activeY1Tile;


void CK_KeenCheckSpecialTileInfo(CK_object *obj);
void StartMusic(unsigned level, boolean repeat);
void StopMusic(void);

CK_GameState ck_gameState;


CK_LevelState ck_levelState;

boolean ck_slowMotionEnabled = false;

// Switch to toggle Camera following keen.
boolean ck_scrollDisabled = false;

// Set if game started with /DEMO parm
int ck_demoParm;

// invincibility switch
boolean ck_godMode;

// invincibility timer
int ck_invincibilityTimer;

// ScoreBox
boolean showscorebox;

// Two button firing
boolean ck_twoButtonFiring;

// Fix jerky motion
boolean ck_fixJerkyMotion;

// SVGA compatibility
boolean ck_svgaCompatibility;

// Gamepad
boolean ck_gamePadEnabled;

// Pogo timer for two-button firing
int ck_pogoTimer;

// Two button shooting variables
ScanCode	firescan = sc_Space;
boolean		oldshooting;


/*
   =============================================================================

   LOCAL VARIABLES

   =============================================================================
*/

// for asm scaning of map planes
unsigned	mapx,mapy,mapxcount,mapycount,maptile,mapspot;

// Active object boundaries
int ck_activeX0Tile, ck_activeX1Tile, ck_activeY0Tile, ck_activeY1Tile;

int			screenYpx;


/*
=============================================================================

						 SCORE BOX ROUTINES

=============================================================================
*/

void	SpawnScore (void);
void CK_UpdateScoreBox (CK_object *ob);
void ScoreReact (CK_object *ob);

void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize);

CK_action CK_ACT_ScoreBox = {NULL,NULL,AT_Frame,false, false,0, 0,0, NULL , NULL, NULL, NULL};
CK_action CK_ACT_DemoSign = {DEMOSIGNSPR,DEMOSIGNSPR,AT_Frame,false, false,0, 0,0, NULL , NULL, NULL, NULL};


/*
======================
=
= SpawnScore
=
======================
*/

void	SpawnScore (void)
{
	ck_scoreBoxObj->type = CT_Friendly;
	ck_scoreBoxObj->active = OBJ_ALWAYS_ACTIVE;
	ck_scoreBoxObj->clipped = false;
	*((long *)&(ck_scoreBoxObj->user1)) = -1L;	// force score to be updated
	ck_scoreBoxObj->user3 = -1;			// and shots
	ck_scoreBoxObj->user4 = -1;			// and lives

	if (ck_inHighScores)
	{
		// Don't display anything in the high scores
		ck_scoreBoxObj->currentAction = NULL;
	}
	else if (DemoMode)
	{
		// If this is a demo, display the DEMO banner
		CK_SetAction(ck_scoreBoxObj, &CK_ACT_DemoSign);
		CA_CacheGrChunk(DEMOSIGNSPR);
	}
	else
	{
		// If a normal game, display the scorebox 
		CK_SetAction(ck_scoreBoxObj, &CK_ACT_ScoreBox);
	}
}

void CK_DemoSign( CK_object *demo)
{
	if (	demo->posX == originxglobal && demo->posY == originyglobal ) 
		return;
	demo->posX = originxglobal;
	demo->posY = originyglobal;

	//place demo sprite in center top
	RF_PlaceSprite( &(demo->sde), demo->posX+0x0A00 - 0x200, demo->posY+0x80,DEMOSIGNSPR,false,3);
}


/*
======================
=
= MemDrawChar
=
======================
*/

#if GRMODE == EGAGR

void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize)
{
asm	mov	si,[char8]
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1		// index into char 8 segment

asm	mov	ds,[WORD PTR grsegs+STARTTILE8*2]
asm	mov	es,[WORD PTR dest+2]

asm	mov	cx,4		// draw four planes
asm	mov	bx,[width]
asm	dec	bx

planeloop:

asm	mov	di,[WORD PTR dest]

asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb

asm	mov	ax,[planesize]
asm	add	[WORD PTR dest],ax

asm	loop	planeloop

asm	mov	ax,ss
asm	mov	ds,ax

}
#endif

#if GRMODE == CGAGR
void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize)
{
asm	mov	si,[char8]
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1		// index into char 8 segment

asm	mov	ds,[WORD PTR grsegs+STARTTILE8*2]
asm	mov	es,[WORD PTR dest+2]

asm	mov	bx,[width]
asm	sub	bx,2

asm	mov	di,[WORD PTR dest]

asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw

asm	mov	ax,ss
asm	mov	ds,ax

	planesize++;		// shut the compiler up
}
#endif


/*
====================
=
= ShiftScore
=
====================
*/
#if GRMODE == EGAGR
void ShiftScore (void)
{
#ifndef NEWMODS
	spritetabletype far *spr;
	spritetype _seg *dest;

	spr = &spritetable[SCOREBOXSPR-STARTSPRITES];
	dest = (spritetype _seg *)grsegs[SCOREBOXSPR];

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[1],spr->width,spr->height,2);

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[2],spr->width,spr->height,4);

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[3],spr->width,spr->height,6);
#endif
}
#endif

/*
===============
=
= CK_UpdateScoreBox
=
===============
*/

void CK_UpdateScoreBox (CK_object *ob)
{
	char		str[10],*ch;
	spritetype	_seg	*block;
	byte		far *dest;
	unsigned	i, length, width, planesize, number;
	boolean 	updated = false;

	// Don't draw anything for the high score level
	if (ck_inHighScores)
		return;

	// Show the demo sign for the demo mode
	if (DemoMode)
	{
		CK_DemoSign(ob);
		return;
	}

	if (!showscorebox)
		return;
//
// score changed
//
	if ((ck_gameState.keenScore>>16) != ob->user1
		|| (unsigned)ck_gameState.keenScore != ob->user2 )
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*4 + 1*CHARWIDTH;

		ltoa (ck_gameState.keenScore,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=8;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user1 = ck_gameState.keenScore>>16;
		ob->user2 = ck_gameState.keenScore;
	}

//
// shots changed
//
	number = ck_gameState.numShots;
	if (number != ob->user3)
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*20 + 7*CHARWIDTH;

		if (number > 99)
			strcpy (str,"99");
		else
			ltoa (number,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=2;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user3 = ck_gameState.numShots;
	}

//
// lives changed
//
	number = ck_gameState.numLives;
	if (number != ob->user4)
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*20 + 2*CHARWIDTH;

		if (number > 99)
			strcpy (str,"99");
		else
			ltoa (number,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=2;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user4 = ck_gameState.numLives;
	}

	if (originxglobal != ob->posX || originyglobal != ob->posY)
	{
		ob->posX = originxglobal;
		ob->posY = originyglobal;
		updated = true;
	}


	if (updated)
#if GRMODE == EGAGR
	RF_PlaceSprite (&ob->sde
		,ob->posX+4*PIXGLOBAL
		,ob->posY+4*PIXGLOBAL
		,SCOREBOXSPR
		,spritedraw
		,PRIORITIES-1);
#endif

#if GRMODE == CGAGR
	RF_PlaceSprite (&ob->sde
		,ob->posX+8*PIXGLOBAL
		,ob->posY+8*PIXGLOBAL
		,SCOREBOXSPR
		,spritedraw
		,PRIORITIES-1);
#endif
}
//===========================================================================
//
// DROPDOWN STATUS WINDOW
//
//===========================================================================

// The status window is drawn to scratch area in the video buffer
// Then it is copied from the scratch to the screen using the RF_ Hook

void CK_DrawLongRight(int x, int y, int digits, int zerotile, long value);
void CK_DrawStatusWindow(void);
void CK_ScrollStatusWindow(void);
void CK_ShowStatusWindow(void);

extern const char *ck_levelNames[];
int ck_statusWindowYPx;
boolean ck_statusDown;
unsigned statusWindowOfs;  // screen buffer


void CK_DrawLongRight(int x, int y, int digits, int zerotile, long value)
{
	char s[20];
	int len,i;


	ltoa(value, s, 10);
	len = strlen(s);

	for (i = digits; i > len; i--)
	{
		VWB_DrawTile8(x, y, zerotile);
		x+=8;
	}

	while (i > 0)
	{
		VWB_DrawTile8(x,y,zerotile + s[len-i] - 47);
		i--;
		x+=8;
	}

}

void CK_DrawStatusWindow(void)
{
	unsigned strW, strH;
	int si, i, oldcolor;


	// Draw the backdrop
	int var2 = 64;
	int di = 16;
	int statusWidth = 184;
	int statusHeight = 144;


	VWB_DrawTile8(var2, di, 54);
	VWB_DrawTile8(var2, di+statusHeight, 60);
	si = var2 + 8;

	while (var2 + statusWidth - 8 >= si)
	{

		VWB_DrawTile8(si, di, 55);
		VWB_DrawTile8(si, di + statusHeight, 61);
		si += 8;
	}

	VWB_DrawTile8(si, di, 56);
	VWB_DrawTile8(si, di + statusHeight, 62);

	si = di + 8;

	while (di + statusHeight - 8 >= si)
	{

		VWB_DrawTile8(var2, si, 57);
		VWB_DrawTile8(var2+statusWidth, si, 59);
		si += 8;
	}

	VWB_Bar(72, 24, 176, 136, 7);

	// Print the stuff
	oldcolor = fontcolor;
	
	// Level
	PrintY = 28;
	WindowX = 80;
	WindowW = 160;
	fontcolor = 15;
	US_CPrint("LOCATION");
	VWB_Bar(79, 38, 162, 20, 15);
	strcpy(str, ck_levelNames[mapon]);
	CK_MeasureMultiline(str, &strW, &strH);
	PrintY = (20 - strH)/2 + 40 - 2;
	US_CPrint(str);

	// Score
	PrintY = 61;
	WindowX = 80;
	WindowW = 64;
	fontcolor = 15;
	US_CPrint("SCORE");

	VWB_Bar(79, 71, 66, 10, 0);
	CK_DrawLongRight(80, 72, 8, 41, ck_gameState.keenScore);

	// Extra man
	PrintY = 61;
	WindowX = 176;
	WindowW = 64;
	US_CPrint("EXTRA");
	VWB_Bar(175, 71, 66, 10, 0);
	CK_DrawLongRight(176, 72, 8, 41, ck_gameState.nextKeenAt);

	// Difficulty
	PrintY = 85;
	WindowX = 176;
	WindowW = 64;
	fontcolor = 15;
	US_CPrint("LEVEL");
	VWB_Bar(175, 95, 66, 10, 0);

	PrintY = 96;
	WindowX = 176;
	WindowW = 64;
	fontcolor = 12;

	switch (ck_gameState.difficulty)
	{
	case 1:
		US_CPrint("Easy");
		break;
	case 2:
		US_CPrint("Normal");
		break;
	case 3:
		US_CPrint("Hard");
		break;
	}

	// Key gems
	PrintX = 80;
	PrintY = 112;
	fontcolor = 15;
	US_Print("KEYS");

	VWB_Bar(119, 111, 34, 10, 0);

	for (i = 0; i < 4; i++)
	{
		if (ck_gameState.keyGems[i])
			VWB_DrawTile8(120+i*8, 112, 36+i);
	}

	// AMMO
	PrintX = 176;
	PrintY = 112;
	US_Print("AMMO");
	VWB_Bar(215, 111, 26, 10, 0);
	CK_DrawLongRight(216, 112, 3, 41, ck_gameState.numShots);

	// Lives
	PrintX = 80;
	PrintY = 128;
	US_Print("KEENS");
	VWB_Bar(127, 127, 18, 10, 0);
	CK_DrawLongRight(128, 128, 2, 41, ck_gameState.numLives);

	// Lifeups
	PrintX = 176;
	PrintY = 128;
	US_Print("LIFEUPS");
	VWB_Bar(224, 127, 16, 10, 0);
	CK_DrawLongRight(224, 128, 2, 41, ck_gameState.numVitalin);

	fontcolor = oldcolor;


}

void CK_ScrollStatusWindow(void)
{
	int dest, height, source;

	if (ck_statusWindowYPx > 152)
	{
		height = ck_statusWindowYPx - 152;
		source = statusWindowOfs + panadjust + 8;
		dest = bufferofs + panadjust + 8;
		VW_ScreenToScreen(source, dest, 24, height);

		VW_ClipDrawMPic((pansx + 136)/8, pansy - (16-height), STATUSTOPPICM);
		source = statusWindowOfs + panadjust + 0x408;
		dest = bufferofs + panadjust + (height << 6) + 8;
		height = 152;
	}
	else 
	{
		source = statusWindowOfs + panadjust + ((152-ck_statusWindowYPx)<<6) + 0x408;
		dest = bufferofs + panadjust + 8;
		height = ck_statusWindowYPx;
	}

	if (height > 0)
		VW_ScreenToScreen(source, dest, 24, height);

	// Draw the tile map underneath the scrolling status box
	if (ck_statusDown)
	{
		// Coming back up, need to redraw the map back underneath
		height = 168 - ck_statusWindowYPx;
		source = masterofs + panadjust + (ck_statusWindowYPx << 6) + 8;
		dest = bufferofs + panadjust + (ck_statusWindowYPx << 6) + 8;
		VW_ScreenToScreen(source, dest, 24, height);

		// Draw underneath the left masked pic
		height = ck_statusWindowYPx;
		source = statusWindowOfs + panadjust + 8 - 3;
		dest = bufferofs + panadjust + 8 - 3;

		if (height > 0)
			VW_ScreenToScreen(source, dest, 3, height);

	}
	else
	{
		// Going down
		height = ck_statusWindowYPx - 72;

		if (height > 0)
		{
			source = statusWindowOfs + panadjust + 8 - 3;
			dest = bufferofs + panadjust + 8 - 3;
			if (height > 0) // ??
				VW_ScreenToScreen(source, dest, 3, height);
		}
	}

	if (ck_statusWindowYPx >= 72)
		VW_ClipDrawMPic((pansx + 40)/8, pansy + ck_statusWindowYPx - 168, STATUSLEFTPICM);

 	VW_UpdateScreen();


}

extern void RFL_InitAnimList(void);
void CK_ShowStatusWindow(void)
{

	int oldBufferofs;
	
	WindowX = 0;
	WindowW = 320;
	WindowY = 0;
	WindowH = 200;

	// This function is called when enter pressed; check for A+2 to enable debug mode
	if (Keyboard[sc_A] && Keyboard[sc_2])
	{
		US_CenterWindow(18, 2);
		PrintY+=2;
		US_Print("Debug keys active");
		VW_UpdateScreen();
		IN_Ack();//IN_WaitButton();
		// debugactive = 1;
		return;
	}



	RF_Refresh();

	// Clear out all animating tiles
	RFL_InitAnimList();

	// Draw the status window to scratch area in the buffer
	oldBufferofs = bufferofs;
	bufferofs = statusWindowOfs = RF_FindFreeBuffer();
	VW_ScreenToScreen(displayofs, displayofs, 44, 224);
	VW_ScreenToScreen(displayofs, masterofs, 44, 224);
	VW_ScreenToScreen(displayofs, bufferofs, 44, 168); 
	CK_DrawStatusWindow();
	bufferofs = oldBufferofs;
	RF_Refresh();
	
	// Scroll the window down
	SD_PlaySound(STATUSDOWNSND);
	ck_statusWindowYPx = 16;
	ck_statusDown = false;
	RF_SetRefreshHook(CK_ScrollStatusWindow);
	do 
	{
		RF_Refresh();
		if (ck_statusWindowYPx == 168)
			break;


		if ((ck_statusWindowYPx += tics*8) <= 168)
			continue;

		ck_statusWindowYPx = 168;

	} while (1);

	RF_Refresh();
	RF_SetRefreshHook(NULL);
	IN_ClearKeysDown();
	IN_Ack();//IN_WaitButton();


	// Scroll the window up
	SD_PlaySound(STATUSUPSND);
	ck_statusWindowYPx -= 16;
	ck_statusDown = true;
	RF_SetRefreshHook(CK_ScrollStatusWindow);

	do 
	{
		RF_Refresh();
		if (ck_statusWindowYPx == 0)
			break;


		if ((ck_statusWindowYPx -= tics*8) >= 0)
			continue;

		ck_statusWindowYPx = 0;

	} while (1);

	RF_SetRefreshHook(NULL);

	ck_scoreBoxObj->posX = 0;

}


//===========================================================================
//
// DEBUG ROUTINES AND INPUT HANDLING
//
//===========================================================================

void CK_CountActiveObjects()
{
}

void DebugMemory (void)
{
	VW_FixRefreshBuffer ();
	US_CenterWindow (16,7);

	US_CPrint ("Memory Usage");
	US_CPrint ("------------");
	US_Print ("Total     :");
	US_PrintUnsigned ((mminfo.mainmem+mminfo.EMSmem+mminfo.XMSmem)/1024);
	US_Print ("k\nFree      :");
	US_PrintUnsigned (MM_UnusedMemory()/1024);
	US_Print ("k\nWith purge:");
	US_PrintUnsigned (MM_TotalFree()/1024);
	US_Print ("k\n");
	VW_UpdateScreen();
	IN_Ack ();
#if GRMODE == EGAGR
	MM_ShowMemory ();
#endif
}

void CK_ItemCheat()
{
	VW_FixRefreshBuffer ();
	US_CenterWindow (12,3);
	US_PrintCentered ("Free items!");
	ck_gameState.numShots=99;
	ck_gameState.securityCard=1;
	ck_gameState.keyGems[0] =
	ck_gameState.keyGems[1] =
	ck_gameState.keyGems[2] =
	ck_gameState.keyGems[3] = 1;
	VW_UpdateScreen();
	IN_Ack ();
}

void CK_OverlayForegroundTile(int fgTile, int overlayTile)
{
	
}

// TODO: make this interoperable between episodes
void CK_WallDebug()
{
}

#define DISPWIDTH	110
#define	TEXTWIDTH   40
void TestSprites(void)
{
	int hx,hy,sprite,oldsprite,bottomy,topx,shift;
	spritetabletype far *spr;
	spritetype _seg	*block;
	unsigned	mem,scan;


	VW_FixRefreshBuffer ();
	US_CenterWindow (30,17);

	US_CPrint ("Sprite Test");
	US_CPrint ("-----------");

	hy=PrintY;
	hx=(PrintX+56)&(~7);
	topx = hx+TEXTWIDTH;

	US_Print ("Chunk:\nWidth:\nHeight:\nOrgx:\nOrgy:\nXl:\nYl:\nXh:\nYh:\n"
			  "Shifts:\nMem:\n");

	bottomy = PrintY;

	sprite = STARTSPRITES;
	shift = 0;

	do
	{
		if (sprite>=STARTTILE8)
			sprite = STARTTILE8-1;
		else if (sprite<STARTSPRITES)
			sprite = STARTSPRITES;

		spr = &spritetable[sprite-STARTSPRITES];
		block = (spritetype _seg *)grsegs[sprite];

		VWB_Bar (hx,hy,TEXTWIDTH,bottomy-hy,WHITE);

		PrintX=hx;
		PrintY=hy;
		US_PrintUnsigned (sprite);US_Print ("\n");PrintX=hx;
		US_PrintUnsigned (spr->width);US_Print ("\n");PrintX=hx;
		US_PrintUnsigned (spr->height);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->orgx);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->orgy);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->xl);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->yl);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->xh);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->yh);US_Print ("\n");PrintX=hx;
		US_PrintSigned (spr->shifts);US_Print ("\n");PrintX=hx;
		if (!block)
		{
			US_Print ("-----");
		}
		else
		{
			mem = block->sourceoffset[3]+5*block->planesize[3];
			mem = (mem+15)&(~15);		// round to paragraphs
			US_PrintUnsigned (mem);
		}

		oldsprite = sprite;
		do
		{
		//
		// draw the current shift, then wait for key
		//
			VWB_Bar(topx,hy,DISPWIDTH,bottomy-hy,WHITE);
			if (block)
			{
				PrintX = topx;
				PrintY = hy;
				US_Print ("Shift:");
				US_PrintUnsigned (shift);
				US_Print ("\n");
				VWB_DrawSprite (topx+16+shift*2,PrintY,sprite);
			}

			VW_UpdateScreen();

			scan = IN_WaitForKey ();

			switch (scan)
			{
			case sc_UpArrow:
				sprite++;
				break;
			case sc_DownArrow:
				sprite--;
				break;
			case sc_LeftArrow:
				if (--shift == -1)
					shift = 3;
				break;
			case sc_RightArrow:
				if (++shift == 4)
					shift = 0;
				break;
			case sc_Escape:
				return;
			}

		} while (sprite == oldsprite);

  } while (1);


}

boolean CK_DebugKeys()
{
	boolean esc;
	int level;

	// NOTE: Following the update to the ID Engine from Catacomb 3-D,
	// some cheat codes have further been imported from the same game,
	// while some additional code has been restored separately.
	// Furthermore, scancode definitions from ID_IN.H are used
	// used now instead of scancode values hardcoded here.

	if (Keyboard[sc_B] && ingame)		// B = border color
	{
		US_CenterWindow(24,3);
		PrintY+=6;
		US_Print(" Border color (0-15):");
		VW_UpdateScreen();
		esc = !US_LineInput (px,py,str,NULL,true,2,0);
		if (!esc)
		{
			level = atoi (str);
			if (level>=0 && level<=15)
				VW_ColorBorder (level);
		}
		return 1;
	}

#if 0

	if (Keyboard[sc_C] && ingame)		// C = count objects
	{
		CountObjects();
		return 1;
	}

#endif

	if (Keyboard[sc_D] && ingame)		// D = start / end demo record
	{
		if (DemoMode == demo_Off)
			CK_StartDemoRecord ();
		else if (DemoMode == demo_Record)
		{
			CK_EndDemoRecord ();
			ck_levelState = LS_LevelComplete;
		}
		return 1;
	}


	if (Keyboard[sc_E] && ingame)	// DEBUG: end + 'E' to quit level
	{
		/*
		if (tedlevel)
			TEDDeath();
		*/
		ck_levelState = LS_LevelComplete;
	}

	if (Keyboard[sc_G] && ingame)		// G = god mode
	{
		VW_FixRefreshBuffer ();
		US_CenterWindow (12,2);
		if (ck_godMode)
		  US_PrintCentered ("God mode OFF");
		else
		  US_PrintCentered ("God mode ON");
		VW_UpdateScreen();
		IN_Ack();
		ck_godMode ^= 1;
		return 1;
	}
	else if (Keyboard[sc_I] && ingame)			// I = item cheat
	{
		CK_ItemCheat();
		VW_UpdateScreen();
		IN_Ack ();
		return 1;
	}
	else if (Keyboard[sc_J] && ingame)			// J = jump cheat
	{
		ck_gameState.jumpCheat^=1;
		VW_FixRefreshBuffer ();
		US_CenterWindow (18,3);
		if (ck_gameState.jumpCheat)
			US_PrintCentered ("Jump cheat ON");
		else
			US_PrintCentered ("Jump cheat OFF");
		VW_UpdateScreen();
		IN_Ack ();
		return 1;
	}
	else if (Keyboard[sc_M] && ingame)			// M = memory info
	{
		DebugMemory();
		return 1;
	}
	else if (Keyboard[sc_N] && ingame)			// N = No clipping
	{
		VW_FixRefreshBuffer ();
		US_CenterWindow (18,3);
		if (ck_keenObj->clipped)
		{
			US_PrintCentered ("No clipping ON");
			ck_keenObj->clipped = false;
		}
		else
		{
			US_PrintCentered ("No clipping OFF");
			ck_keenObj->clipped = true;
		}
		VW_UpdateScreen();
		IN_Ack ();
		return 1;
	}
	else if (Keyboard[sc_P] && ingame)			// P = pause with no screen disruptioon
	{
		IN_Ack();
		return 1;
	}
	else if (Keyboard[sc_S] && ingame)	// S = slow motion
	{
		ck_slowMotionEnabled^=1;
		VW_FixRefreshBuffer ();
		US_CenterWindow (18,3);
		if (ck_slowMotionEnabled)
			US_PrintCentered ("Slow motion ON");
		else
			US_PrintCentered ("Slow motion OFF");
		VW_UpdateScreen();
		IN_Ack ();
		return 1;
	}
	else if (Keyboard[sc_V])			// V = extra VBLs
	{
		US_CenterWindow(30,3);
		PrintY+=6;
		US_Print("  Add how many extra VBLs(0-8):");
		VW_UpdateScreen();
		esc = !US_LineInput (px,py,str,NULL,true,2,0);
		if (!esc)
		{
			level = atoi (str);
			if (level>=0 && level<=8)
				extravbls = level;
		}
		return 1;
	}
	else if (Keyboard[sc_T])			// T = sprite test
	{
		TestSprites();
		return 1;
	}
	else if (Keyboard[sc_W] && ingame)	// W = warp to level
	{
		VW_FixRefreshBuffer ();
		US_CenterWindow(26,3);
		PrintY+=6;
		US_Print("  Warp to which level(0-25):");
		VW_UpdateScreen();
		esc = !US_LineInput (px,py,str,NULL,true,2,0);
		if (!esc)
		{
			level = atoi (str);
			if (level>=0 && level<=NUMMAPS)
			{
				ck_gameState.currentLevel = level;
				ck_levelState = LS_WarpToLevel;
			}
		}
		return 1;
	}
	return 0;
}


void CK_CheckKeys(void)
{
	// TODO: Also check for a gamepad button when relevant

	if (screenfaded)
		return;

	// Drop down status
	if (Keyboard[sc_Enter])
	{
		CK_ShowStatusWindow();
		IN_ClearKeysDown();
		RF_ForceRefresh();
		TimeCount = lasttimecount;
	}

	// TODO: If Paused
	if (Paused)
	{
		SD_MusicOff();
		VW_FixRefreshBuffer();
		US_CenterWindow(8, 3);
		US_PrintCentered("PAUSED");
		VW_UpdateScreen(); // VW_UpdateScreen();
		IN_Ack();//IN_WaitButton();
		RF_ForceRefresh();
		Paused = false;
		SD_MusicOn();
	}

	// HELP
	if (LastScan == sc_F1)
	{
		StopMusic();
		HelpScreens();
		StartMusic(ck_gameState.currentLevel, true);

		// Force scorebox redraw if it's enabled
		if (showscorebox)
		{
			ck_scoreBoxObj->user1 = ck_scoreBoxObj->user2 = ck_scoreBoxObj->user3 = ck_scoreBoxObj->user4 = -1;
			// Non-vanilla addition: redraw the scorebox immediately without
			// waiting for a PlayLoop
			CK_UpdateScoreBox(ck_scoreBoxObj);
		}

		RF_ForceRefresh();

	}


	if (!ck_demoParm)
	{
		// Go back to wristwatch
		if ((LastScan >= sc_F2 && LastScan <= sc_F7) || LastScan == sc_Escape)
		{

			VW_FixRefreshBuffer();
			StopMusic();
			US_ControlPanel();

			StartMusic(ck_gameState.currentLevel, true);

			// Wipe the scorebox if it got disabled
			if (!showscorebox && ck_scoreBoxObj->sde)
				RF_RemoveSprite(&ck_scoreBoxObj->sde);

			// Force scorebox redraw if it's enabled
			if (showscorebox)
			{
				ck_scoreBoxObj->user1 = ck_scoreBoxObj->user2 = ck_scoreBoxObj->user3 = ck_scoreBoxObj->user4 = -1;
				// Non-vanilla addition: redraw the scorebox immediately without
				// waiting for a PlayLoop

				// CK_UpdateScoreBox(ck_scoreBoxObj);
			}

			IN_ClearKeysDown();

			// Check if the user manager ended the game
			if (restartgame)
				ck_levelState = 5;

			else if (!loadedgame)
				RF_ForceRefresh(); 

			if (abortgame)
			{
				abortgame = 0;
				ck_levelState = 8;
			}

			if (loadedgame)
				ck_levelState = 6;

			// gameticks_2 = TimeCount
			// FIXME: Is this the right way to handle this?
			lasttimecount = TimeCount;
		}

		// Do Boss Key
		if (LastScan == sc_F9)
		{

		}
	}


	// BAT ITEM CHEAT
	if (Keyboard[sc_B] && Keyboard[sc_A] && Keyboard[sc_T])
	{
		CK_ItemCheat();
	}

	// Debug Keys
	if (Keyboard[sc_F10])
	{
		if (CK_DebugKeys())
		{
			RF_ForceRefresh(); //RF_ResetScreen();
			lasttimecount = TimeCount;
		}
	}

	// TODO: CTRL+S sound

	// CTRL + Q
	if (Keyboard[sc_Control] && LastScan == sc_Q)
	{

		IN_ClearKeysDown();
		Quit(NULL);
	}
}


void CK_HandleInput()
{
	IN_ReadControl(0, &ck_inputFrame);

	if (ck_inputFrame.yaxis != -1)
		ck_keenState.keenSliding = false;

	if (!ck_gamePadEnabled || (DemoMode != demo_Off))
	{
		// Two button firing mode is used for demo playback
		if (!ck_twoButtonFiring && (DemoMode == demo_Off))
		{
			ck_keenState.jumpIsPressed = ck_inputFrame.button0;
			ck_keenState.pogoIsPressed = ck_inputFrame.button1;
			//ck_keenState.shootIsPressed = ck_inputFrame.button2; // use kbddefs, not button2
			ck_keenState.shootIsPressed = Keyboard[firescan];
			if (!ck_keenState.jumpIsPressed) ck_keenState.jumpWasPressed = false;
			if (!ck_keenState.pogoIsPressed) ck_keenState.pogoWasPressed = false;
			if (!ck_keenState.shootIsPressed) ck_keenState.shootWasPressed = false;
		}
		else
		{

			// Check for two-button firing
			if (ck_inputFrame.button0 && ck_inputFrame.button1)
			{
				ck_keenState.shootIsPressed = true;
				ck_keenState.jumpIsPressed = false;
				ck_keenState.pogoIsPressed = false;
				ck_keenState.jumpWasPressed = false;
				ck_keenState.pogoWasPressed = false;
				return;
			}

			ck_keenState.shootWasPressed = false;
			ck_keenState.shootIsPressed = false;

			if (ck_inputFrame.button0)
			{
				ck_keenState.jumpIsPressed = true;
			}
			else
			{
				ck_keenState.jumpWasPressed = false;
				ck_keenState.jumpIsPressed = false;
			}

			if (ck_inputFrame.button1)
			{
				// Here be dragons!
				// In order to better emulate the original trilogy's controls, a delay
				// is introduced when pogoing in two-button firing.
				if (ck_pogoTimer <= 8)
				{
					ck_pogoTimer += tics;
				}
				else
				{
					ck_keenState.pogoIsPressed = true;
				}
			}
			else
			{
				// If the player lets go of pogo, pogo immediately.
				if (ck_pogoTimer)
				{
					ck_keenState.pogoIsPressed = true;
				}
				else
				{
					ck_keenState.pogoWasPressed = false;
					ck_keenState.pogoIsPressed = false;
				}
				ck_pogoTimer = 0;
			}
		}
	}
	else
	{
		// TODO: Gravis Gamepad input handling
	}
}

//===========================================================================
//
// OBJECT LIST
//
//===========================================================================

void CK_SetupObjArray()
{
		int i;
		for (i = 0; i < CK_MAX_OBJECTS; ++i)
		{
				ck_objArray[i].prev = &(ck_objArray[i + 1]);
				ck_objArray[i].next = 0;
		}

		ck_objArray[CK_MAX_OBJECTS - 1].prev = 0;

		ck_freeObject = &ck_objArray[0];
		ck_lastObject = 0;
		ck_numObjects = 0;

		ck_keenObj = CK_GetNewObj(false);

		ck_scoreBoxObj = CK_GetNewObj(false);
}

CK_object *CK_GetNewObj(boolean nonCritical)
{
		CK_object *newObj;

		if (!ck_freeObject)
		{
				if (nonCritical)
				{
						//printf("Warning: No free spots in objarray! Using temp object\n");
						return &tempObj;
				}
				else
						Quit("GetNewObj: No free spots in objarray!");
		}

		newObj = ck_freeObject;
		ck_freeObject = ck_freeObject->prev;

		//Clear any old crap out of the struct.
		memset(newObj, 0, sizeof (CK_object));


		if (ck_lastObject)
		{
				ck_lastObject->next = newObj;
		}
		newObj->prev = ck_lastObject;


		newObj->active = OBJ_ACTIVE;
		newObj->clipped = CLIP_normal;

		ck_lastObject = newObj;
		ck_numObjects++;


		return newObj;
}

void CK_RemoveObj(CK_object *obj)
{
		if (obj == ck_keenObj)
		{
				Quit("RemoveObj: Tried to remove the player!");
		}

		// TODO: Make a better spritedraw handler that
		// replaces the user int variables
		RF_RemoveSprite(&obj->sde);

		if (obj->type == CT_StunnedCreature)
		{
				// FIXME: This cast is bad on 64-bit platforms
				RF_RemoveSprite((void *)&obj->user3);
		}

		if (obj == ck_lastObject)
				ck_lastObject = obj->prev;
		else
				obj->next->prev = obj->prev;

		obj->prev->next = obj->next;
		//obj->next = 0;

		obj->prev = ck_freeObject;
		ck_freeObject = obj;
		ck_numObjects--;
}


//===========================================================================
//
// ACTION STATES
//
//===========================================================================

int CK_ActionThink(CK_object *obj, int time)
{
	int newTime, remainingTime;
	CK_action *action = obj->currentAction;


	// ThinkMethod: 2
	if (action->type == AT_Frame)
	{
		if (action->think)
		{
			if (obj->timeUntillThink)
			{
				obj->timeUntillThink--;
			}
			else
			{
				action->think(obj);
			}
		}
		return 0;
	}

	newTime = time + obj->actionTimer;

	// If we won't run out of time.
	if (action->timer > newTime || !(action->timer))
	{
		obj->actionTimer = newTime;

		if (action->type == AT_ScaledOnce || action->type == AT_ScaledFrame)
		{
			if (obj->xDirection)
			{
				//TODO: Work out what to do with the nextVelocity stuff.
				ck_nextX += action->velX * (time * obj->xDirection);
			}
			if (obj->yDirection)
			{
				ck_nextY += action->velY * (time * obj->yDirection);
			}
		}

		if (action->type == AT_UnscaledFrame || action->type == AT_ScaledFrame)
		{
			if (action->think)
			{
				if (obj->timeUntillThink)
					obj->timeUntillThink--;
				else
				{
					action->think(obj);
				}
			}
		}
		return 0;
	}

	remainingTime = action->timer - obj->actionTimer;
	newTime -= action->timer;
	obj->actionTimer = 0;

	if (action->type == AT_ScaledOnce || action->type == AT_ScaledFrame)
	{
		if (obj->xDirection)
		{
			ck_nextX += action->velX * (remainingTime * obj->xDirection);
		}
		if (obj->yDirection)
		{
			ck_nextY += action->velY * (remainingTime * obj->yDirection);
		}
	}
	else /*if (action->type == AT_UnscaledOnce || action->type == AT_UnscaledFrame)*/
	{
		if (obj->xDirection)
		{
			ck_nextX += action->velX * obj->xDirection;
		}
		if (obj->yDirection)
		{
			ck_nextY += action->velY * obj->yDirection;
		}
	}

	if (action->think)
	{
		if (obj->timeUntillThink)
			obj->timeUntillThink--;
		else
		{
			action->think(obj);
		}
	}

	if (action != obj->currentAction)
	{
		if (!obj->currentAction)
		{
			return 0;
		}
	}
	else
	{
		obj->currentAction = action->next;
	}
	return newTime;
}

void CK_RunAction(CK_object *obj)
{
	int ticsLeft;
	CK_action *prevAction;
	int oldChunk = obj->gfxChunk;

	//TODO: Check these
	//int oldPosX = obj->posX;
	//int oldPosY = obj->posY;

	obj->deltaPosX = obj->deltaPosY = 0;

	ck_nextX = ck_nextY = 0;

	prevAction = obj->currentAction;

	ticsLeft = CK_ActionThink(obj, tics);

	if (obj->currentAction != prevAction)
	{
		obj->actionTimer = 0;
		prevAction = obj->currentAction;
	}
	// TODO/FIXME(?): Vanilla code doesn't check if prevAction is non-NULL,
	// but the new code may crash as a consequence (try no-clip cheat).
	while (prevAction && ticsLeft)
	{
		if (prevAction->protectAnimation || prevAction->timer > ticsLeft)
		{
			ticsLeft = CK_ActionThink(obj, ticsLeft);
		}
		else
		{
			ticsLeft = CK_ActionThink(obj, prevAction->timer - 1);
		}

		if (obj->currentAction != prevAction)
		{
			obj->actionTimer = 0;
			prevAction = obj->currentAction;
		}

	}

	if (!prevAction)
	{
		CK_RemoveObj(obj);
		return;
	}
	if (prevAction->chunkRight)
	{
		obj->gfxChunk = (obj->xDirection > 0) ? prevAction->chunkRight : prevAction->chunkLeft;
	}
	if (obj->gfxChunk == -1)
	{
		obj->gfxChunk = 0;
	}
#if 0
	if (obj->currentAction->chunkLeft && obj->xDirection <= 0) obj->gfxChunk = obj->currentAction->chunkLeft;
	if (obj->currentAction->chunkRight && obj->xDirection > 0) obj->gfxChunk = obj->currentAction->chunkRight;
#endif
	if (obj->gfxChunk != oldChunk || ck_nextX || ck_nextY || obj->topTI == 0x19)
	{
		if (obj->clipped == CLIP_full)
			CK_PhysFullClipToWalls(obj);
		if (obj->clipped == CLIP_simple)
			CK_PhysUpdateSimpleObj(obj);
		else
			CK_PhysUpdateNormalObj(obj);
	}
}


//===========================================================================
//
// LEVEL MUSIC
//
//===========================================================================

const int level_music[] = {
		WORLD_MAP_MUS,          // World Map Music
		LEVEL_1_MUS,         // Level 1 Music
		LEVEL_1_MUS,         // Level 1 Music
};

void StartMusic(unsigned level, boolean repeat)
{
	int songtoplay;

	if ((level >= sizeof(level_music)/sizeof(unsigned)) && (level != 0xFFFF))
	{
		Quit("StartMusic() - bad level number");
	}
	SD_MusicOff();

	songtoplay = level_music[level];


	if (songtoplay == -1)
		return;
	if (MusicMode != smm_AdLib)
		return;
	MM_BombOnError(false);
	CA_CacheAudioChunk(STARTMUSIC + songtoplay);
	MM_BombOnError(true);

	if (mmerror)
	{
		int faded;
		mmerror = false;
		if (DemoMode)
			return;
		US_CenterWindow(20, 8);
		PrintY += 20;
		US_CPrint("Insufficient memory\nfor background music!");
		VW_UpdateScreen();
		faded = screenfaded;
		if (faded)
			VW_SetDefaultColors();
		IN_ClearKeysDown();
		IN_UserInput(210, false);
		if (faded)
			VW_FadeOut();
	}

	RepeatMusic = repeat;
	SD_StartMusic((MusicGroup far *) audiosegs[STARTMUSIC + songtoplay]);
}

void StopMusic(void)
{
	int i;
	SD_MusicOff();
	for (i = 0; i < LASTMUSIC; i++)

		if (audiosegs[STARTMUSIC + i])
			MM_SetPurge((memptr *) &audiosegs[STARTMUSIC + i], 3);
}




//===========================================================================
//
// CAMERA
//
//===========================================================================
void CK_SetActivityLimits(void)
{
	originxtilemax = originxtile + PORTTILESWIDE - 1;
	originytilemax = originytile + PORTTILESHIGH - 1;

	ck_activeX0Tile = originxtile - 6;
	if (ck_activeX0Tile < 0)
		ck_activeX0Tile = 0;

	ck_activeX1Tile = originxtilemax + 6;
	if (ck_activeX1Tile < 0)
		ck_activeX1Tile = 0;

	ck_activeY0Tile = originytile - 6;
	if (ck_activeY0Tile < 0)
		ck_activeY0Tile = 0;

	ck_activeY1Tile = originytilemax + 6;
	if (ck_activeY1Tile < 0)
		ck_activeY1Tile = 0;
}

void CK_CentreCamera(CK_object *obj)
{
	unsigned screenX, screenY;

	screenYpx = 140;

	if (obj->posX < (152 << 4))
		screenX = 0;
	else
		screenX = obj->posX - (152 << 4);

	if (mapon == 0)
	{
		// World Map
		if (obj->posY < (80 << 4))
			screenY = 0;
		else
			screenY = obj->posY - (80 << 4);
	}
	else
	{
		// In Level
		if (obj->clipRects.unitY2 < (140 << 4))
			screenY = 0;

		else
			screenY = obj->clipRects.unitY2 - (140 << 4);
	}

	// TODO: Find out why this is locking the game up
	if (!ck_inHighScores)
		RF_NewPosition(screenX, screenY);

	CK_SetActivityLimits();
}

/*
 * Move the camera that follows keen on the world map
 */

void CK_MapCamera( CK_object *keen )
{
	int scr_y, scr_x;

	if (ck_scrollDisabled)
		return;

	// Scroll Left, Right, or nowhere
	if ( keen->clipRects.unitX1 < originxglobal + (144 << 4) )
		scr_x = keen->clipRects.unitX1 - (originxglobal + (144 << 4));
	else if ( keen->clipRects.unitX2 > originxglobal + (192 << 4) )
		scr_x = keen->clipRects.unitX2 + 16 - (originxglobal + (192 << 4));
	else
		scr_x = 0;

	// Scroll Up, Down, or nowhere
	if ( keen->clipRects.unitY1 < originyglobal + (80 << 4) )
		scr_y = keen->clipRects.unitY1 - (originyglobal + (80 << 4));
	else if ( keen->clipRects.unitY2 > originyglobal + (112 << 4) )
		scr_y = keen->clipRects.unitY2 - (originyglobal + (112 << 4));
	else
		scr_y = 0;

	// Limit scrolling to 256 map units (1 tile)
	// And update the active boundaries of the map
	if ( scr_x != 0 || scr_y != 0 )
	{
		if ( scr_x >= 256 )
			scr_x = 255;
		else if ( scr_x <= -256 )
			scr_x = -255;

		if ( scr_y >= 256 )
			scr_y = 255;
		else if ( scr_y <= -256 )
			scr_y = -255;

		RF_Scroll( scr_x, scr_y );

		CK_SetActivityLimits();

	}
}

// Run the normal camera which follows keen

void CK_NormalCamera(CK_object *obj)
{

	int pxToMove, cmpAmt;
	int deltaX = 0, deltaY = 0;	// in Units

	//TODO: some unknown var must be 0
	//This var is a "ScrollDisabled flag." If keen dies, it's set so he 
	// can fall out the bottom
	if (ck_scrollDisabled)
		return;

	// End level if keen makes it out either side
	if (obj->clipRects.unitX1 < originxmin || obj->clipRects.unitX2 > originxmax + (320 << 4))
	{
		ck_levelState = 2;
		return;
	}

	// Kill keen if he falls out the bottom
	if (obj->clipRects.unitY2 > (originymax + (208 << 4)))
	{
		obj->posY -= obj->clipRects.unitY2 - (originymax + (208 << 4));
		SD_PlaySound(KEENFALLSND);
		ck_godMode = false;
		CK_KillKeen();
		return;
	}


	// Keep keen's x-coord between 144-192 pixels
	if (obj->posX < (originxglobal + (144 << 4)))
		deltaX = obj->posX - (originxglobal + (144 << 4));

	if (obj->posX > (originxglobal + (192 << 4)))
		deltaX = obj->posX - (originxglobal + (192 << 4));


	// Keen should be able to look up and down.
	if (obj->currentAction == &CK_ACT_keenLookUp2)
	{
		if (screenYpx + tics > 167)
		{
			// Keen should never be so low on the screen that his
			// feet are more than 167 px from the top.
			pxToMove = 167 - screenYpx;
		}
		else
		{
			// Move 1px per tick.
			pxToMove = tics;
		}
		screenYpx += pxToMove;
		deltaY = (-pxToMove) << 4;

	}
	else if (obj->currentAction == &CK_ACT_keenLookDown3)
	{
		int pxToMove;
		if (screenYpx - tics < 33)
		{
			// Keen should never be so high on the screen that his
			// feet are fewer than 33 px from the top.
			pxToMove = screenYpx - 33;
		}
		else
		{
			// Move 1px/tick.
			pxToMove = tics;
		}
		screenYpx -= pxToMove;
		deltaY = pxToMove << 4;
	}

	// If we're attached to the ground, or otherwise awesome
	// do somethink inscrutible.
	if (obj->topTI || !obj->clipped || obj->currentAction == &CK_ACT_keenHang1)
	{
		if (obj->currentAction != &CK_ACT_keenPull1 &&
				obj->currentAction != &CK_ACT_keenPull2 &&
				obj->currentAction != &CK_ACT_keenPull3 &&
				obj->currentAction != &CK_ACT_keenPull4)
		{
			deltaY += obj->deltaPosY;

			//TODO: Something hideous
			// TODO: Convert to 16-bit once the rest is converted
			// (due to unsigned vs signed mess)
			cmpAmt = (screenYpx << 4) + originyglobal + deltaY;
			if (cmpAmt != obj->clipRects.unitY2)
			{
				int oneDiff, otherDiff;
				if (obj->clipRects.unitY2 < cmpAmt)
					oneDiff = cmpAmt - obj->clipRects.unitY2;
				else
					oneDiff = obj->clipRects.unitY2 - cmpAmt;

				// TODO: Unsigned shift left,
				// followed by a signed shift right...
				otherDiff = (signed)((unsigned)oneDiff << 4) >> 7;
				if (otherDiff > 48)
					otherDiff = 48;
				otherDiff *= tics;
				if (otherDiff < 16)
				{
					if (oneDiff < 16)
						otherDiff = oneDiff;
					else
						otherDiff = 16;
				}
				if (obj->clipRects.unitY2 < cmpAmt)
					deltaY -= otherDiff;
				else
					deltaY += otherDiff;
#if 0
				int adjAmt = (((screenYpx << 4) + originyglobal + deltaY - obj->clipRects.unitY2));
				int adjAmt2 = abs(adjAmt / 8);
				adjAmt2 = (adjAmt2 <= 48) ? adjAmt2 : 48;
				if (adjAmt > 0)
					deltaY -= adjAmt2;
				else
					deltaY += adjAmt2;
#endif
			}
		}

	}
	else
	{
		// Reset to 140px.
		screenYpx = 140;
	}


	// Scroll the screen to keep keen between 33 and 167 px.
	if (obj->clipRects.unitY2 < (originyglobal + deltaY + (32 << 4)))
		deltaY += obj->clipRects.unitY2 - (originyglobal + deltaY + (32 << 4));


	if (obj->clipRects.unitY2 > (originyglobal + deltaY + (168 << 4)))
		deltaY += obj->clipRects.unitY2 - (originyglobal + deltaY + (168 << 4));

	//Don't scroll more than one tile's worth per frame.
	if (deltaX || deltaY)
	{
		if (deltaX > 255) deltaX = 255;
		else if (deltaX < -255) deltaX = -255;

		if (deltaY > 255) deltaY = 255;
		else

			if (deltaY < -255) deltaY = -255;

		// Do the scroll!
		RF_Scroll(deltaX, deltaY);

		CK_SetActivityLimits();

	}
}


//===========================================================================


/*
   ============================
   =
   = PlayLoop
   =
   ============================
*/

void CK_PlayLoop (void)
{

	CK_object *currentObj, *collideObj;

	StartMusic(ck_gameState.currentLevel, true);

	ck_pogoTimer = 0;
	memset(&ck_keenState, 0, sizeof(ck_keenState));
	ck_invincibilityTimer = 0;
	ck_scrollDisabled = false;
	ck_keenState.jumpWasPressed = ck_keenState.pogoWasPressed = ck_keenState.shootWasPressed = false;
	ingame = 1;

	// If this is nonzero, the level will quit immediately.
	ck_levelState = LS_Playing;

	//ck_keenState.pogoTimer = ck_scrollDisabled = ck_keenState.invincibilityTimer = 0;

	CK_CentreCamera(ck_keenObj);

	// Note that this appears in CK_LoadLevel as well
	if (DemoMode)
		US_InitRndT(false);
	else
		US_InitRndT(true);

	tics = 3;
	lasttimecount = 3;
	TimeCount = 3;
 
	while (ck_levelState == LS_Playing)
	{

		CK_HandleInput();

		// Set, unset active objects.
		for (currentObj = ck_keenObj; currentObj; currentObj = currentObj->next)
		{

			if (!currentObj->active &&
					(currentObj->clipRects.tileX2 >= originxtile - 1) &&
					(currentObj->clipRects.tileX1 <= originxtilemax + 1) &&
					(currentObj->clipRects.tileY1 <= originytilemax + 1) &&
					(currentObj->clipRects.tileY2 >= originytile - 1))
			{
				currentObj->visible = true;
				currentObj->active = OBJ_ACTIVE;
			}
			if (currentObj->active)
			{
				if ((currentObj->clipRects.tileX2 < ck_activeX0Tile) ||
				    (currentObj->clipRects.tileX1 > ck_activeX1Tile) ||
				    (currentObj->clipRects.tileY1 > ck_activeY1Tile) ||
				    (currentObj->clipRects.tileY2 < ck_activeY0Tile))
				{
					//TODO: Add an Episode callback. Ep 4 requires
					// type 33 to remove int33 (Andy's decomp)
					// For Ep 5 that's type 7
					if (currentObj->active == OBJ_EXISTS_ONLY_ONSCREEN)
					{
						CK_RemoveObj(currentObj);
						continue;
					}
					else if (currentObj->active != OBJ_ALWAYS_ACTIVE)
					{
						if (US_RndT() < tics * 2 || screenfaded)
						{
							RF_RemoveSprite(&currentObj->sde);
							if (currentObj->type == CT_StunnedCreature)
								RF_RemoveSprite((void *)&currentObj->user3);
							currentObj->active = OBJ_INACTIVE;
							continue;
						}
					}
				}

				// Object is active, so process its action amd update its physics
				CK_RunAction(currentObj);
			}
		}


		if (ck_keenState.platform)
			CK_KeenRidePlatform(ck_keenObj);

		for (currentObj = ck_keenObj; currentObj; currentObj = currentObj->next)
		{
			// Some strange Keen4 stuff here. Ignoring for now.


			if (!currentObj->active) continue;
			for (collideObj = currentObj->next; collideObj; collideObj = collideObj->next)
			{
				if (!collideObj->active)
					continue;

				if (	(currentObj->clipRects.unitX2 > collideObj->clipRects.unitX1) &&
						(currentObj->clipRects.unitX1 < collideObj->clipRects.unitX2) &&
						(currentObj->clipRects.unitY1 < collideObj->clipRects.unitY2) &&
						(currentObj->clipRects.unitY2 > collideObj->clipRects.unitY1) )
				{
					if (currentObj->currentAction->collide)
						currentObj->currentAction->collide(currentObj, collideObj);
					if (collideObj->currentAction->collide)
						collideObj->currentAction->collide(collideObj, currentObj);
				}
			}
		}

		//TODO: If world map and keen4, check wetsuit.

		//TODO: If not world map, check keen -> item-tile collision.

		if (mapon == 0)
			CK_MapMiscFlagsCheck(ck_keenObj);
		else
			CK_KeenCheckSpecialTileInfo(ck_keenObj);


		for (currentObj = ck_keenObj; currentObj; currentObj = currentObj->next)
		{
			if (currentObj->active)
			{
				if (currentObj->clipRects.tileY2 >= (mapheight - 1))
				{
					if (currentObj->type == CT_Player)
					{
						// Kill Keen if he exits the bottom of the map.
						ck_levelState = LS_Died;
						continue;
					}
					else
					{
						CK_RemoveObj(currentObj);
						continue;
					}
				}
				if (currentObj->visible && currentObj->currentAction->draw)
				{
					currentObj->visible = false;	//We don't need to render it twice!
					currentObj->currentAction->draw(currentObj);
				}
			}
		}

		// Follow the player with the camera.
		if (mapon == 0)
			CK_MapCamera(ck_keenObj);
		else
			CK_NormalCamera(ck_keenObj);

		//Draw the scorebox
		CK_UpdateScoreBox(ck_scoreBoxObj);

		// Clear the loaded game flag, in case this is the 
		// first playloop iteration after we've resumed a savegame
		if (loadedgame)
			loadedgame = false;

		// 0xef for the X-direction to match EGA keen's 2px horz scrolling.
		RF_Refresh();

		if (ck_invincibilityTimer)
		{
			ck_invincibilityTimer -= tics;
			if (ck_invincibilityTimer < 0)
				ck_invincibilityTimer = 0;
		}

		//TODO: Slow-mo, extra VBLs.
		if (ck_slowMotionEnabled)
		{
			VW_WaitVBL(14);
			lasttimecount = TimeCount;
		}

		// TODO: Extra VBLs come here
		// VW_UpdateScreen();

		// If we've finished playing back our demo, or the player presses a key,
		// exit the playloop.
		if (DemoMode == demo_Playback)
		{
			if (!screenfaded && (LastScan != sc_None))
			{
				ck_levelState = LS_LevelComplete;
				if (LastScan != sc_F1)
					LastScan = sc_Space;
			}
		}
		else if (DemoMode == demo_PlayDone)
		{
			ck_levelState = LS_LevelComplete;
		}
		else
		{
			CK_CheckKeys();
		}
		// End-Of-Game cheat
#if 0
		if (Keyboard[sc_E] && Keyboard[sc_N] && Keyboard[sc_D])
		{
			ck_levelState = 15;
		}
#endif
	}
	ingame = 0;
	StopMusic();


	ingame = false;
	// Patch from Catacomb 3-D for updated ID Engine (control panel)
	abortgame = false;
}
