/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

//////////////////////////////////////////
//
// Graphics .H file for .CKD
// IGRAB-ed on Fri Nov 19 16:58:34 1993
// Updated for ID Engine from Catacomb 3-D
//
//////////////////////////////////////////

typedef enum {
		H_MENUPIC=6,
		H_HANDPIC=7,
		H_TOPWINDOWPIC=8,	
		H_LEFTWINDOWPIC=9,
		H_RIGHTWINDOWPIC=10,
		H_BOTTOMINFOPIC=11,
		H_BOTTOMWINDOWPIC=12,


		// Lump Start
		CP_MAINMENUPIC=13,
		CP_NEWGAMEMENUPIC=14,
		CP_LOADMENUPIC=15,
		CP_SAVEMENUPIC=16,
		CP_CONFIGMENUPIC=17,
		CP_SOUNDMENUPIC=18,
		CP_MUSICMENUPIC=19,
		CP_KEYBOARDMENUPIC=20,
		CP_KEYMOVEMENTPIC=21,
		CP_KEYBUTTONPIC=22,
		CP_JOYSTICKMENUPIC=23,
		CP_OPTIONSMENUPIC=24,
		CP_PADDLEWARPIC=25,
		CP_QUITPIC=26,
		CP_JOYSTICKPIC=27,
		CP_MENUSCREENPIC=28,

		// Lump Start
		I_IDMODPIC=29,
		I_ARRANGEDPIC=30,
		I_HELPFROMPIC=31,
		I_CATFACEPIC=32,

		STARWARSPIC=33,
		TITLEPIC=34,

		CD_KEENPIC=35,
		CD_FIVEPIC=36,
		CD_FOURPIC=37,
		CD_THREEPIC=38,
		CD_TWOPIC=39,
		CD_ONEPIC=40,


		CP_MENUMASKPICM=41,
		STATUSTOPPICM=42,
		STATUSLEFTPICM=43,

		PADDLESPR=44,
		BALLSPR=45,
		BALL1PIXELTOTHERIGHTSPR=46,
		BALL2PIXELTOTHERIGHTSPR=47,
		BALL3PIXELTOTHERIGHTSPR=48,

		DEMOSIGNSPR=49,

		KEENSTANDRSPR=50,
		KEENRUNR1SPR=51,
		KEENRUNR2SPR=52,
		KEENRUNR3SPR=53,
		KEENRUNR4SPR=54,
		KEENJUMPR1SPR=55,
		KEENJUMPR2SPR=56,
		KEENJUMPR3SPR=57,
		KEENSTANDLSPR=58,
		KEENRUNL1SPR=59,
		KEENRUNL2SPR=60,
		KEENRUNL3SPR=61,
		KEENRUNL4SPR=62,
		KEENJUMPL1SPR=63,
		KEENJUMPL2SPR=64,
		KEENJUMPL3SPR=65,
		KEENLOOKUPSPR=66,
		KEENANGRY1SPR=67,
		KEENANGRY2SPR=68,
		KEENSHRUGSPR=69,
		KEENBOOK1SPR=70,
		KEENBOOK2SPR=71,
		KEENBOOK3SPR=72,
	       	KEENBOOK4SPR=73,
	       	KEENBOOKREADSPR=74,
	       	KEENBOOKFLIP1SPR=75,
	       	KEENBOOKFLIP2SPR=76,
	       	KEENPUTBOOKAWAY1SPR=77,
		KEENPUTBOOKAWAY2SPR=78,
		KEENLOOKATWATCHSPR=79,
		KEENLOOKDOWN1SPR=80,
		KEENLOOKDOWN2SPR=81,
		KEENDIE1SPR=82,
		KEENDIE2SPR=83,
		STUNNEDSTARS1SPR=84,
		STUNNEDSTARS2SPR=85,
		STUNNEDSTARS3SPR=86,
		KEENSHOOTLEFTSPR=87,
		KEENJUMPSHOOTLEFTSPR=88,
		KEENJUMPSHOOTDOWNSPR=89,
		KEENJUMPSHOOTUPSPR=90,
		KEENSHOOTUPSPR=91,
		KEENSHOOTRIGHTSPR=92,
		KEENJUMPSHOOTRIGHTSPR=93,
		STUNNER1SPR=94,
		STUNNER2SPR=95,
		STUNNER3SPR=96,
		STUNNER4SPR=97,
		STUNNERDIE1SPR=98,
		STUNNERDIE2SPR=99,
		KEENPOLECLIMBR1SPR=100,
		KEENPOLECLIMBR2SPR=101,
		KEENPOLECLIMBR3SPR=102,
		KEENPOLESLIDE1SPR=103,
		KEENPOLESLIDE2SPR=104,
		KEENPOLESLIDE3SPR=105,
		KEENPOLESLIDE4SPR=106,
		KEENPOLECLIMBL1SPR=107,
		KEENPOLECLIMBL2SPR=108,
		KEENPOLECLIMBL3SPR=109,
		KEENPOLESHOOTUPLSPR=110,
		KEENPOLESHOOTUPRSPR=111,
		KEENPOLESHOOTDOWNRSPR=112,
		KEENPOLESHOOTDOWNLSPR=113,
		KEENPOLESHOOTLEFTSPR=114,
		KEENPOLESHOOTRIGHTSPR=115,
		KEENWALKAWAY1SPR=116,
		KEENWALKAWAY2SPR=117,
		KEENWALKAWAY3SPR=118,
		KEENWALKAWAY4SPR=119,
		KEENWALKAWAY5SPR=120,
		KEENHANGLSPR=121,
		KEENHANGRSPR=122,
		KEENCLIMBL1SPR=123,
		KEENCLIMBL2SPR=124,
		KEENCLIMBL3SPR=125,
		KEENCLIMBL4SPR=126,
		KEENCLIMBR1SPR=127,
		KEENCLIMBR2SPR=128,
		KEENCLIMBR3SPR=129,
		KEENCLIMBR4SPR=130,
		KEENPOGORSPR=131,
		KEENPOGOBOUNCERSPR=132,
		KEENPOGOLSPR=133,
		KEENPOGOBOUNCELSPR=134,

		VITALINBURST1SPR=135,
		VITALINBURST2SPR=136,
		VITALINBURST3SPR=137,
		VITALIN1UPSHADOWSPR=138,
		POINTS100SHADOWSPR=139,
		POINTS200SHADOWSPR=140,
		POINTS500SHADOWSPR=141,
		POINTS1000SHADOWSPR=142,
		POINTS2000SHADOWSPR=143,
		POINTS5000SHADOWSPR=144,
		POINTS1UPSHADOWSPR=145,
		STUNNERSHADOWSPR=146,
		POINTS100ITEM1SPR=147,
		POINTS100ITEM2SPR=148,
		POINTS200ITEM1SPR=149,
		POINTS200ITEM2SPR=150,
		POINTS500ITEM1SPR=151,
		POINTS500ITEM2SPR=152,
		POINTS1000ITEM1SPR=153,
		POINTS1000ITEM2SPR=154,
		POINTS2000ITEM1SPR=155,
		POINTS2000ITEM2SPR=156,
		POINTS5000ITEM1SPR=157,
		POINTS5000ITEM2SPR=158,
		ITEM3UP1SPR=159,	
		ITEM3UP2SPR=160,
		ITEM3UPSHADOW=161,
		REDGEM1SPR=162,
		REDGEM2SPR=163,
		YELLOWGEM1SPR=164,
		YELLOWGEM2SPR=165,
		BLUEGEM1SPR=166,
		BLUEGEM2SPR=167,
		GREENGEM1SPR=168,
		GREENGEM2SPR=169,
		GEMSHADOWSPR=170,
		ITEMSTUNNER1SPR=171,
		ITEMSTUNNER2SPR=172, 

		SCOREBOXSPR = 173,

		WORLDKEENL1SPR=174,
		WORLDKEENL2SPR=175,
		WORLDKEENL3SPR=176,
		WORLDKEENR1SPR=177,
		WORLDKEENR2SPR=178,
		WORLDKEENR3SPR=179,
		WORLDKEENU1SPR=180,
		WORLDKEENU2SPR=181,
		WORLDKEENU3SPR=182,
		WORLDKEEND1SPR=183,
		WORLDKEEND2SPR=184,
		WORLDKEEND3SPR=185,
		WORLDKEENDR1SPR=186,
		WORLDKEENDR2SPR=187,
		WORLDKEENDR3SPR=188,
		WORLDKEENDL1SPR=189,
		WORLDKEENDL2SPR=190,
		WORLDKEENDL3SPR=191,
		WORLDKEENUL1SPR=192,
		WORLDKEENUL2SPR=193,
		WORLDKEENUL3SPR=194,
		WORLDKEENUR1SPR=195,
		WORLDKEENUR2SPR=196,
		WORLDKEENUR3SPR=197,
		WORLDKEENWAVE1SPR=198,
		WORLDKEENWAVE2SPR=199,
		FLAGFLIP1SPR=200,
		FLAGFLIP2SPR=201,
		FLAGFLIP3SPR=202,
		FLAGFLIP4SPR=203,
		FLAGFLIP5SPR=204,
		FLAGFLIP6SPR=205,
		FLAGFLIP7SPR=206,
		FLAGWAVE1SPR=207,
		FLAGWAVE2SPR=208,
		FLAGWAVE3SPR=209,
		FLAGWAVE4SPR=210,

		PLATFORMSPR=211,

		I_COMMANDEREXTERN=4440,
		I_KEENEXTERN=4441,

		T_HELPMAIN=4426,
		T_HELPSTORY=4427,
		T_HELPCONTROLS=4428,
		T_HELPABOUT=4429,
		T_ENDDIALOGUE=4430,
		T_HELPEXTRA=4431,
		T_HELPORDER=4432,

		ANSI_ENDTEXT=4439,
		ANSI_OUTOFMEM=4442,

	     } graphicnums;

//
// Data LUMPs
//
#define CONTROLS_LUMP_START		13
#define CONTROLS_LUMP_END		28
#define KEEN_LUMP_START			50
#define KEEN_LUMP_END			173
#define WORLDKEEN_LUMP_START		174
#define WORLDKEEN_LUMP_END		210
#define PLATFORM_LUMP_START		211
#define PLATFORM_LUMP_END		211

#define PADDLE_LUMP_START		44
#define PADDLE_LUMP_END			48
//
// Amount of each data item
//
#define NUMCHUNKS    4444
#define NUMFONT      3
#define NUMFONTM     0
#define NUMPICS      35
#define NUMPICM      3
#define NUMSPRITES   168
#define NUMTILE8     104
#define NUMTILE8M    20
#define NUMTILE16    1296
#define NUMTILE16M   2916
#define NUMTILE32    0
#define NUMTILE32M   0
//
// File offsets for data items
//
#define STRUCTPIC    0
#define STRUCTPICM   1
#define STRUCTSPRITE 2

#define STARTFONT    3
#define STARTFONTM   6
#define STARTPICS    6
#define STARTPICM    41
#define STARTSPRITES 44
#define STARTTILE8   212
#define STARTTILE8M  213
#define STARTTILE16  214
#define STARTTILE16M 1510
#define STARTTILE32  4426
#define STARTTILE32M 4426
// Hack for Catacomb 3-D's ID_CA.C
#define STARTEXTERNS 4426
#define STARTDEMOS   4433

//
// Thank you for using IGRAB!
//
